
-- ZIPPO & ADRIANO
gloriaCP12 = {};

function gloriaCP12.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function gloriaCP12:load(xmlFile)
    self.lastGrainLevel = 0;
    self.fulie = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fulie#index"));
    self.fulie1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fulie1#index"));
    self.fulie2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fulie2#index"));
    self.fulie3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fulie3#index"));    
    self.fulieRotation = 0;

    self.angrenaj = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.valt#index"));
    self.angrenaj1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rola1#index"));
    self.angrenaj2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rola2#index"));
    self.angrenaj3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rola3#index"));
    self.angrenaj4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fulieMica#index")); 
    self.angrenaj5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fulieMica1#index"));
    self.angrenaj6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fulieMica2#index")); 
    self.angrenajRotation = 0;
    
    self.angrenaj7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fulieMare#index"));
    self.angrenaj8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fulieMare1#index"));
    self.angrenaj9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.fulieMare2#index"));
    self.angrenajRotation1 = 0;
    
    self.angrenaj10 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.afuliemica#index"));
    self.angrenaj11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.afuliemica1#index")); 
    self.angrenajRotation2 = 0;
    
    self.angrenaj12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.valtHeder#index")); 
    self.angrenajRotation3 = 0;
    
    self.pipeGrainParticleSystem = {};
    self.pipeGrainParticleSystemindex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.pipeGrainParticleSystem#index"));
    Utils.loadParticleSystem(xmlFile, self.pipeGrainParticleSystem, "vehicle.pipeGrainParticleSystem", self.pipeGrainParticleSystemindex, false, nil, self.baseDirectory);

    self.pipeRapeParticleSystem = {};
    self.pipeRapeParticleSystemindex = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.pipeRapeParticleSystem#index"));
    Utils.loadParticleSystem(xmlFile, self.pipeRapeParticleSystem, "vehicle.pipeRapeParticleSystem", self.pipeRapeParticleSystemindex, false, nil, self.baseDirectory); 

 	-- miscari site -- 
		local seperatorPartNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.seperatorPart1#index"));
    if seperatorPartNode1 ~= nil then
        self.seperatorPart1 = {};
        self.seperatorPart1.node = seperatorPartNode1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart1#minRot"));
        self.seperatorPart1.minRot = {};
        self.seperatorPart1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart1#maxRot"));
        self.seperatorPart1.maxRot = {};
        self.seperatorPart1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.seperatorPart1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart1#rotTime"), 2);
        self.seperatorPart1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart1#touchRotLimit"), 10));
    end;
	
	local seperatorPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.seperatorPart2#index"));
    if seperatorPartNode2 ~= nil then
        self.seperatorPart2 = {};
        self.seperatorPart2.node = seperatorPartNode2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart2#minRot"));
        self.seperatorPart2.minRot = {};
        self.seperatorPart2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart2#maxRot"));
        self.seperatorPart2.maxRot = {};
        self.seperatorPart2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.seperatorPart2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart2#rotTime"), 2);
        self.seperatorPart2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart2#touchRotLimit"), 10));
    end;
	
	local seperatorPartNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.seperatorPart3#index"));
    if seperatorPartNode3 ~= nil then
        self.seperatorPart3 = {};
        self.seperatorPart3.node = seperatorPartNode3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart3#minRot"));
        self.seperatorPart3.minRot = {};
        self.seperatorPart3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart3#maxRot"));
        self.seperatorPart3.maxRot = {};
        self.seperatorPart3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.seperatorPart3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart3#rotTime"), 2);
        self.seperatorPart3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart3#touchRotLimit"), 10));
    end;
	
	local seperatorPartNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.seperatorPart4#index"));
    if seperatorPartNode4 ~= nil then
        self.seperatorPart4 = {};
        self.seperatorPart4.node = seperatorPartNode4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart4#minRot"));
        self.seperatorPart4.minRot = {};
        self.seperatorPart4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart4#maxRot"));
        self.seperatorPart4.maxRot = {};
        self.seperatorPart4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.seperatorPart4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart4#rotTime"), 2);
        self.seperatorPart4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart4#touchRotLimit"), 10));
    end;
	
	local seperatorPartNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.seperatorPart5#index"));
    if seperatorPartNode5 ~= nil then
        self.seperatorPart5 = {};
        self.seperatorPart5.node = seperatorPartNode5;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart5#minRot"));
        self.seperatorPart5.minRot = {};
        self.seperatorPart5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart5#maxRot"));
        self.seperatorPart5.maxRot = {};
        self.seperatorPart5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.seperatorPart5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart5#rotTime"), 2);
        self.seperatorPart5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart5#touchRotLimit"), 10));
    end;
	
	
	local seperatorPartNode6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.seperatorPart6#index"));
    if seperatorPartNode6 ~= nil then
        self.seperatorPart6 = {};
        self.seperatorPart6.node = seperatorPartNode6;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart6#minRot"));
        self.seperatorPart6.minRot = {};
        self.seperatorPart6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.seperatorPart6#maxRot"));
        self.seperatorPart6.maxRot = {};
        self.seperatorPart6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.seperatorPart6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.seperatorPart6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.seperatorPart6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart6#rotTime"), 2);
        self.seperatorPart6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.seperatorPart6#touchRotLimit"), 10));
    end;
	
	self.seperatorPart7 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.seperatorPart7#index"));   
    
end;

function gloriaCP12:delete()
end;

function gloriaCP12:mouseEvent(posX, posY, isDown, isUp, button)
end;

function gloriaCP12:keyEvent(unicode, sym, modifier, isDown)
    
end;

function gloriaCP12:update(dt)
	if self.isThreshing then
	   --if self.motor.lastMotorRpm > 0.01 then
		self.fulieRotation = self.fulieRotation + 10;
		setRotation(self.fulie, Utils.degToRad(self.fulieRotation), 0, 0);
		setRotation(self.fulie1, Utils.degToRad(self.fulieRotation), 0, 0);	
	 	setRotation(self.fulie2, Utils.degToRad(self.fulieRotation), 0, 0);
 	  setRotation(self.fulie3, Utils.degToRad(self.fulieRotation), 0, 0);        	
	  -- end;
	

	for cutter,implement in pairs(self.attachedCutters) do
                if cutter.reelStarted then
			if self.lastGrainLevel < self.grainTankFillLevel then
				if self.currentGrainTankFruitType == FruitUtil.FRUITTYPE_RAPE then
					Utils.setEmittingState(self.pipeRapeParticleSystem, true);
				else
					Utils.setEmittingState(self.pipeGrainParticleSystem, true);
				end;
			else
			  	Utils.setEmittingState(self.pipeGrainParticleSystem, false);
				Utils.setEmittingState(self.pipeRapeParticleSystem, false);
			end;
			self.lastGrainLevel = self.grainTankFillLevel;

			self.angrenajRotation = self.angrenajRotation - 9;
			setRotation(self.angrenaj, 0, Utils.degToRad(self.angrenajRotation), 0);
	    setRotation(self.angrenaj1, Utils.degToRad(self.angrenajRotation), 0, 0);	
      setRotation(self.angrenaj2, Utils.degToRad(self.angrenajRotation), 0, 0);
      setRotation(self.angrenaj3, Utils.degToRad(self.angrenajRotation), 0, 0);	
      setRotation(self.angrenaj4, Utils.degToRad(self.angrenajRotation), 0, 0);
      setRotation(self.angrenaj5, Utils.degToRad(self.angrenajRotation), 0, 0);
      setRotation(self.angrenaj6, Utils.degToRad(self.angrenajRotation), 0, 0);	
	    self.angrenajRotation1 = self.angrenajRotation1 + 7; 
	    setRotation(self.angrenaj7, Utils.degToRad(self.angrenajRotation1), 0, 0);	
	    setRotation(self.angrenaj8, Utils.degToRad(self.angrenajRotation1), 0, 0);	
	    setRotation(self.angrenaj9, Utils.degToRad(self.angrenajRotation1), 0, 0);
      self.angrenajRotation2 = self.angrenajRotation2 + 20;
      setRotation(self.angrenaj10, Utils.degToRad(self.angrenajRotation2), 0, 0);
      setRotation(self.angrenaj11, Utils.degToRad(self.angrenajRotation2), 0, 0);
      self.angrenajRotation3 = self.angrenajRotation3 + 10; 
      setRotation(self.angrenaj12, Utils.degToRad(self.angrenajRotation3), 0, 0);
		    else
			Utils.setEmittingState(self.pipeGrainParticleSystem, false);
			Utils.setEmittingState(self.pipeRapeParticleSystem, false);
		    end;
	end;
	              
	for cutter,implement in pairs(self.attachedCutters) do
                if cutter.reelStarted then
		  if self.seperatorPart1 ~= nil then
            local x, y, z = getRotation(self.seperatorPart1.node);
            local minRot = self.seperatorPart1.minRot;
			local maxRot = self.seperatorPart1.maxRot;
            local eps = self.seperatorPart1.touchRotLimit;

            if math.abs(x-minRot[1]) < eps and math.abs(y-minRot[2]) < eps and math.abs(z-minRot[3]) < eps then
				self.rotationDirection = false;
			elseif math.abs(maxRot[1]-x) < eps and math.abs(maxRot[2]-y) < eps and math.abs(maxRot[3]-z) < eps then
				self.rotationDirection = true;
			end;
		end;
	end;
end;
  	
		for cutter,implement in pairs(self.attachedCutters) do
                if cutter.reelStarted then	
		if self.seperatorPart1 ~= nil then
			local x, y, z = getRotation(self.seperatorPart1.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.seperatorPart1.maxRot, self.seperatorPart1.minRot, 3, self.seperatorPart1.rotTime / 3, 7, self.rotationDirection);
			setRotation(self.seperatorPart1.node, unpack(newRot));
		end;
	end;	
end;

		for cutter,implement in pairs(self.attachedCutters) do
                if cutter.reelStarted then	
		if self.seperatorPart2 ~= nil then
			local x, y, z = getRotation(self.seperatorPart2.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.seperatorPart2.maxRot, self.seperatorPart2.minRot, 3, self.seperatorPart2.rotTime / 3, 7, self.rotationDirection);
			setRotation(self.seperatorPart2.node, unpack(newRot));
		end;
	end;	
end;
		
		for cutter,implement in pairs(self.attachedCutters) do
                if cutter.reelStarted then	
		if self.seperatorPart3 ~= nil then
			local x, y, z = getRotation(self.seperatorPart3.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.seperatorPart3.maxRot, self.seperatorPart3.minRot, 3, self.seperatorPart3.rotTime / 3, 7, self.rotationDirection);
			setRotation(self.seperatorPart3.node, unpack(newRot));
		end;
	end;	
end;		

		for cutter,implement in pairs(self.attachedCutters) do
                if cutter.reelStarted then	
		if self.seperatorPart4 ~= nil then
			local x, y, z = getRotation(self.seperatorPart4.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.seperatorPart4.maxRot, self.seperatorPart4.minRot, 3, self.seperatorPart4.rotTime / 3, 7, self.rotationDirection);
			setRotation(self.seperatorPart4.node, unpack(newRot));
		end;
	end;	
end;
	
  	for cutter,implement in pairs(self.attachedCutters) do
                if cutter.reelStarted then	
		if self.seperatorPart5 ~= nil then
			local x, y, z = getRotation(self.seperatorPart5.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.seperatorPart5.maxRot, self.seperatorPart5.minRot, 3, self.seperatorPart5.rotTime / 3, 7, self.rotationDirection);
			setRotation(self.seperatorPart5.node, unpack(newRot));
		end;
	end;	
end;
		
	for cutter,implement in pairs(self.attachedCutters) do
                if cutter.reelStarted then	
		if self.seperatorPart6 ~= nil then
			local x, y, z = getRotation(self.seperatorPart6.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.seperatorPart6.maxRot, self.seperatorPart6.minRot, 3, self.seperatorPart6.rotTime / 3, 7, self.rotationDirection);
			setRotation(self.seperatorPart6.node, unpack(newRot));
		end;
	end;
end;	
		
	for cutter,implement in pairs(self.attachedCutters) do
                if cutter.reelStarted then		
		rotate(self.seperatorPart7, 7*0.012*3, 0, 0);
	   end; 
	end; 
	
	else
	
		setRotation(self.fulie, 0, 0, 0);
		setRotation(self.fulie1, 0, 0, 0);	
	 	setRotation(self.fulie2, 0, 0, 0);
 	  setRotation(self.fulie3, 0, 0, 0); 
	  setRotation(self.angrenaj, 0, 0, 0);
	    setRotation(self.angrenaj1, 0, 0, 0);	
      setRotation(self.angrenaj2, 0, 0, 0);
      setRotation(self.angrenaj3, 0, 0, 0);	
      setRotation(self.angrenaj4, 0, 0, 0);
      setRotation(self.angrenaj5, 0, 0, 0);
      setRotation(self.angrenaj6, 0, 0, 0);	
	    setRotation(self.angrenaj7, 0, 0, 0);	
	    setRotation(self.angrenaj8, 0, 0, 0);	
	    setRotation(self.angrenaj9, 0, 0, 0);
        setRotation(self.angrenaj10, 0, 0, 0);
      setRotation(self.angrenaj11, 0, 0, 0);
      setRotation(self.angrenaj12, 0, 0, 0);
	
end;	 
end;
function gloriaCP12:draw()



  end;